/**
  * =========================================================================
  *  Copyright (C) since 1995 by Leidson CAF & PlanetaMessenger.org
  *
  *  This module is developed and maintained by PlanetaMessenger.org. 
  *  Specs, New and updated versions can be found in 
  *  http://www.planetamessenger.org
  *  If you want contact the Team please send a email to Project Manager
  *  Leidson Campos Alves Ferreira at leidson@planetamessenger.org
  *
  *  Copyright (C) since 1995 by PlanetaMessenger.org
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
  *  the Free Software Foundation; either version 2 of the License, or
  *  (at your option) any later version.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *  GNU General Public License for more details.
  *
  *  You should have received a copy of the GNU General Public License
  *  along with this program; if not, write to the Free Software
  *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  * ===========================================================================
  */

/**
  *
  * $Id: absbase.cpp 46 2011-03-08 13:23:21Z popolony2k $
  * $Author: popolony2k $
  * $Date: 2011-03-08 13:23:21 +0000 (Tue, 08 Mar 2011) $
  * $Revision: 46 $
  * $HeadURL: file:///svn/p/oldskooltech/code/msx/trunk/tools/cpp/sound/mml2msd/absbase.cpp $
  */

#include "absbase.h"


/**
  * Implemwnt the base for all conversion process.
  * Override this method if you need extra processing.
  */
bool AbstractBase :: Run( void )  {

  if( Compile() )
    return Link();

  return false;
}

/**
  * Enable/Disable show information for verbose mode.
  * @param bEnableVerbose The new value for verbose information;
  */
void AbstractBase :: SetVerbose( bool bEnableVerbose )  {
  
  AbstractBase :: bEnableVerbose = bEnableVerbose;
}
  
/**
  * Return the verbose mode information.
  */
bool AbstractBase :: GetVerbose( void )  {
  
  return bEnableVerbose;
}

/**
  * Set the option for enable remarks on generated MSD MML
  * file.
  * @param bEnableRemarks The new settings for remarks;
  */
void AbstractBase :: SetRemarks( bool bEnableRemarks )  {
  
  AbstractBase :: bEnableRemarks = bEnableRemarks;
}

/**
  * Return if generated MSD MML file will be generated with
  * reamarks;
  */
bool AbstractBase :: GetRemarks( void )  {
 
  return bEnableRemarks; 
}

/**
  * Set the flag to find music tempo based on input MML.
  * When this flag is set, the compiler will try to find 
  * the tempo from on source MML and apply it to all
  * other existing channels.
  * @param bFindTempo The new set to find tempo flag;
  */
void AbstractBase :: SetFindTempo( bool bFindTempo )  {
  
  AbstractBase :: bFindTempo = bFindTempo; 
}
  
/**
  * Get the find tempo flag value assigned by the
  * @see SetFindTempo() method;
  */
bool AbstractBase :: GetFindTempo( void )  {

  return bFindTempo; 
}

/**
  * Set the flag to remove all instruments os destination
  * MML.
  * @param bRemoveInstruments The new value to remove
  * instruments flag;
  */
void AbstractBase :: SetRemoveInstruments( bool bRemoveInstruments )  {

  AbstractBase :: bRemoveInstruments = bRemoveInstruments;
}
  
/**
  * Return the remove instruments flag assigned by
  * @see SetRemoveInstruments();
  */
bool AbstractBase :: GetRemoveInstruments( void )  {
 
  return bRemoveInstruments;
}
