/**
  * =========================================================================
  *  Copyright (C) since 1995 by Leidson CAF & PlanetaMessenger.org
  *
  *  This module is developed and maintained by PlanetaMessenger.org. 
  *  Specs, New and updated versions can be found in 
  *  http://www.planetamessenger.org
  *  If you want contact the Team please send a email to Project Manager
  *  Leidson Campos Alves Ferreira at leidson@planetamessenger.org
  *
  *  Copyright (C) since 1995 by PlanetaMessenger.org
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
  *  the Free Software Foundation; either version 2 of the License, or
  *  (at your option) any later version.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *  GNU General Public License for more details.
  *
  *  You should have received a copy of the GNU General Public License
  *  along with this program; if not, write to the Free Software
  *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  * ===========================================================================
  */

/**
  *
  * $Id: msdtokens.h 47 2011-03-08 13:53:39Z popolony2k $
  * $Author: popolony2k $
  * $Date: 2011-03-08 13:53:39 +0000 (Tue, 08 Mar 2011) $
  * $Revision: 47 $
  * $HeadURL: file:///svn/p/oldskooltech/code/msx/trunk/tools/cpp/sound/mml2msd/msdtokens.h $
  */

#ifndef __MSL_TOKENS__
#define __MSL_TOKENS__

/**
  * Accepted tokens by MSD parser.
  */
#define MSD_TOKEN_GENERATED_FILE         "; MSD file generated by mml2msd compiler."
#define MSD_TOKEN_COPYLEFT               "; CopyLeft (c) since 2011 by PlanetaMessenger.org."
#define MSD_TOKEN_CHANNELS_DEFINITIONS   "; Channels definitions"
#define MSD_TOKEN_MML_CONTENT            "; Channels MML content"
#define MSD_TOKEN_CUSTOM_MML_DEFINITIONS "; User custom MML definitions"
#define MSD_TOKEN_REMARK                 ";"
#define MSD_TOKEN_COMMA                  ","
#define MSD_TOKEN_DOT                    '.'
#define MSD_TOKEN_SPACE                  ' '
#define MSD_TOKEN_L                      'L'
#define MSD_R_TOKEN                      'R'
#define MSD_TOKEN_V                      'V'
#define MSD_TOKEN_T                      'T'
#define MSD_TOKEN_1                      '1'
#define MSD_TOKEN_5                      '5'
#define MSD_TOKEN_LESS_THAN              '<'
#define MSD_TOKEN_TILDE                  '~'
#define MSD_TOKEN_ASSIGN_VALUE           "="
#define MSD_TOKEN_AMPERSAND              "&"
#define MSD_TOKEN_AT                     "@"
#define MSD_TOKEN_EOL                    "\n"
#define MSD_TOKEN_EOF                    0x1a
#define MSD_TOKEN_FM1                    "FM1"
#define MSD_TOKEN_FM2                    "FM2"
#define MSD_TOKEN_FM3                    "FM3"
#define MSD_TOKEN_FM4                    "FM4"
#define MSD_TOKEN_FM5                    "FM5"
#define MSD_TOKEN_FM6                    "FM6"
#define MSD_TOKEN_FMR                    "FMR"
#define MSD_TOKEN_FM7                    "FM7"
#define MSD_TOKEN_FM8                    "FM8"
#define MSD_TOKEN_FM9                    "FM9"
#define MSD_TOKEN_PSG1                   "PSG1"
#define MSD_TOKEN_PSG2                   "PSG2"
#define MSD_TOKEN_PSG3                   "PSG3"
#define MSD_TOKEN_SCC1                   "SCC1"
#define MSD_TOKEN_SCC2                   "SCC2"
#define MSD_TOKEN_SCC3                   "SCC3"
#define MSD_TOKEN_SCC4                   "SCC4"
#define MSD_TOKEN_SCC5                   "SCC5"
#define MSD_FM_TOKEN                     "FM"
#define MSD_PSG_TOKEN                    "PSG"
#define MSD_SCC_TOKEN                    "SCC"

/**
  * Valid MML commands.
  */
#define MSD_MML_TEMPO_TOKEN              "t"

/**
  * Command boundaries.
  */
#define MSD_MML_MAX_VOLUME_VALUE         15

/**
  * Channel Id definitions.
  */
#define MSD_FMR_ID                       7
#define MSD_MAX_FM_CHANNELS              10
#define MSD_MAX_PSG_CHANNELS             3
#define MSD_MAX_SCC_CHANNELS             5
#define MSD_MAX_CHANNELS                 MSD_MAX_FM_CHANNELS + MSD_MAX_PSG_CHANNELS + MSD_MAX_SCC_CHANNELS

#endif  // __MSD_TOKENS__
