/**
  * =========================================================================
  *  Copyright (C) since 1995 by Leidson CAF & PlanetaMessenger.org
  *
  *  This module is developed and maintained by PlanetaMessenger.org. 
  *  Specs, New and updated versions can be found in 
  *  http://www.planetamessenger.org
  *  If you want contact the Team please send a email to Project Manager
  *  Leidson Campos Alves Ferreira at leidson@planetamessenger.org
  *
  *  Copyright (C) since 1995 by PlanetaMessenger.org
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
  *  the Free Software Foundation; either version 2 of the License, or
  *  (at your option) any later version.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *  GNU General Public License for more details.
  *
  *  You should have received a copy of the GNU General Public License
  *  along with this program; if not, write to the Free Software
  *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  * ===========================================================================
  */

/**
  *
  * $Id: threeml.h 47 2011-03-08 13:53:39Z popolony2k $
  * $Author: popolony2k $
  * $Date: 2011-03-08 13:53:39 +0000 (Tue, 08 Mar 2011) $
  * $Revision: 47 $
  * $HeadURL: file:///svn/p/oldskooltech/code/msx/trunk/tools/cpp/sound/mml2msd/threeml.h $
  */

#ifndef __THREEML_H__
#define __THREEML_H__

#include <fstream>
#include <iostream>
#include "absbase.h"
#include "basictypes.h"

using namespace std;

/**
  * Channel type definition.
  */
enum ChannelType  {
  CHANNEL_TYPE_FM = 0,
  CHANNEL_TYPE_PSG,
  CHANNEL_TYPE_SCC
};


class ThreeML : public AbstractBase  {
  
  fstream            in;
  fstream            out;
  string             strInputFileName;
  string             strOutputFileName;
  TokenVectorMap     compiledMML;
  ChannelMap         channels;
  CustomMMLMap       customMML;
  int                nChannelId;
  int                nVarCount;
  bool               bTempoFound;


  void AmpersandFilter( string &strToken );
  void CombineQuarterNotesFilter( string &strToken );
  void OctaveLowerFilter( string &strToken );
  void DotFilter( string &strToken );
  void TildeFilter( string &strToken );
  void InvalidVolumeFilter( string &strToken );
  void InstrumentsFilter( string &strToken );
  void PreFilters( void );
  void FindTempo( string strToken );

  protected:

  TokenType CheckToken( string strToken );
  void ExtractTokenValue( TokenType type, string strToken, stToken &token );
  void FilterValue( string &strToken );
  void AddToken( stToken *pTokenSection, TokenVector *pTokenVector );
  void MakeChannel( ChannelType channelType, int nChannelId );
  
  bool Compile( void );
  bool Link( void );
  void Clear( void );
 
  public:

  ThreeML( const string strInputFileName, const string strOutputFileName );
  virtual ~ThreeML( void );

  bool Open( void );
  bool Close( void );
  void AddCustomMML( std :: string strCustomMML, int nChannel = ALL_CHANNELS );
  void RemovelAllCustomMML( void );
};

#endif  // __THREEML_H__
